#include "ImageRecorder.h"

ImageRecorder::ImageRecorder(QObject *parent) : QObject(parent)
{
    capturedImages = 0;
    //ctor
}

ImageRecorder::~ImageRecorder()
{
    //dtor
}

void ImageRecorder::SLOT_startCapture(const ConfigStructure *config)
{
    time.start();
    currentConfig = config;
    capturing = true;
    //start timer depending on the fps
    int secondsPerFrame = (int)((1.0f/(float)currentConfig->fps)*1000.0f);
    timerId = startTimer(secondsPerFrame);
    recX = currentConfig->captureRectangle->x();
    recY = currentConfig->captureRectangle->y();
    recW = currentConfig->captureRectangle->width();
    recH = currentConfig->captureRectangle->height();

    if(currentConfig->imageHandler != 0) currentConfig->imageHandler->startHandler();
}

void ImageRecorder::SLOT_stopCapture()
{
    if(currentConfig->imageHandler != 0) currentConfig->imageHandler->stopHandler();
    capturing = false;
    killTimer(timerId);
    //time.stop();
}

//every timerinterval will a screenshot be taken
//if capturing
void ImageRecorder::timerEvent(QTimerEvent *event)
{
    if(capturing)
    {
        QPixmap p;
        p = QPixmap::grabWindow( (currentConfig->theDesktop)->screen()->winId(), recX,recY,recW,recH);
        if(currentConfig->observer != 0) (currentConfig->observer)->updateAndStoreTexture(p);
        if(currentConfig->imageHandler != 0) (currentConfig->imageHandler)->handleImage(p);
        int ms = time.elapsed();

        float fps = (1000.0/(float)ms);
        std::cout << "Captures/s " << fps << std::endl;
        capturedImages++;
        time.restart();
    }
}
