#ifndef IMAGERECORDER_H
#define IMAGERECORDER_H

#include "useful.h"
#include <QTime>

//Contains function to capture the image
//uses a config struct to choose which functions to call
//to handle the captured images

class ImageRecorder : public QObject
{
        Q_OBJECT
    public:
        ImageRecorder(QObject *parent = 0);
        virtual ~ImageRecorder();

        int capturedImages;

        //Signal to use with an observer or other class which is not an ImageHandler
    signals:
        void SIG_imageCaptured(const QImage &);

    public slots:
        void SLOT_startCapture(const ConfigStructure *);
        void SLOT_stopCapture();

    protected:
        void timerEvent(QTimerEvent *event);

    private:
        const ConfigStructure *currentConfig;
        bool capturing;
        int timerId;
        int recX,recY,recW,recH;
        QTime time;
};

#endif // IMAGERECORDER_H
