#include "tcpserverimagehandler.h"

TcpServerImagehandler::TcpServerImagehandler(int port)
{
    tcpServer = new QTcpServer();
    tcpServer->listen(QHostAddress::Any,port);

    std::cout << "Server status:\n" << (tcpServer->errorString()).toLatin1().data() << "\nPort: "
              << tcpServer->serverPort() << std::endl;

    connect(tcpServer, SIGNAL(newConnection()), this, SLOT(SLOT_addClient()));
    clientConnection = new QTcpSocket();
}

TcpServerImagehandler::~TcpServerImagehandler()
{
    delete tcpServer;
    delete clientConnection;
    delete clientBufferStream;
}

int TcpServerImagehandler::handleImage(const QPixmap &pmap)
{

    //If socket is connected
    if(clientConnection->state() == QAbstractSocket::ConnectedState) {

        //The request image functionallity is temporary removed as
        //getChar crash.
        #ifdef WAITFORCLIENT
        std::cout << clientConnection->bytesAvailable() << std::endl;
        if(clientConnection->bytesToWrite()==0 && clientConnection->bytesAvailable()==1) {

        char* request = "";
        clientConnection->getChar(request);
        clientConnection->reset();
        std::cout << request << std::endl;
        #else

        if(clientConnection->bytesToWrite()==0) {
        #endif
        //save image in a byte array which will be sent
        QByteArray imTosend;
        QDataStream out(&imTosend, QIODevice::WriteOnly);

        //write size of buffer and imaage to stream
        out << (quint64)0;
        out << pmap;
        out.device()->seek(0);
        out << (quint64)(imTosend.size() - sizeof(quint64));

        //write buffer to socket
        clientConnection->write(imTosend);
        std::cout << "Buffer length " << imTosend.size() << std::endl;
        std::cout << "Image buffered to socket " << clientConnection->bytesToWrite() << std::endl;

        } else {
            std::cout << "CLIENT NOT READY" << std::endl;
        }
    }
    return 0;
}

void TcpServerImagehandler::SLOT_addClient()
{
    clientConnection = tcpServer->nextPendingConnection();
    connect(clientConnection, SIGNAL(disconnected()),
             this, SLOT(SLOT_removeClient()));
    clientBufferStream = new QDataStream(clientConnection);
    clientConnection->open(QIODevice::ReadWrite);
    clientConnection->waitForConnected();
    std::cout << "Client " << clientConnection->peerAddress().toString().toLatin1().data() << " connected!" << std::endl;
}

void TcpServerImagehandler::SLOT_removeClient()
{
    std::cout << "Client disconnected!" << std::endl;
    clientConnection->abort();
}
