#ifndef TCPSERVERIMAGEHANDLER_H
#define TCPSERVERIMAGEHANDLER_H

#include <ImageHandler.h>
#include <QObject>
#include <QTcpServer>
#include <QTcpSocket>
#include <iostream>

//The server handles connections and sends images to client
class TcpServerImagehandler :  public ImageHandler
{
    Q_OBJECT

    public:
        TcpServerImagehandler(int port);
        ~TcpServerImagehandler();

        void startHandler() {std::cout << "Server started loop.\n" <<std::endl;}
        int handleImage(const QPixmap &);
        void stopHandler() {std::cout << "Server ended loop.\n" <<std::endl;}

    public slots:
        void SLOT_startSendingimage() {}
        void SLOT_addClient();
        void SLOT_removeClient();

    protected:
    private:
        QTcpServer *tcpServer;

        QDataStream* clientBufferStream;
        QTcpSocket* clientConnection;

        QPixmap* currentPixmap;
};

#endif // TCPSERVERIMAGEHANDLER_H
